# Protocol Specifications for ROSE

## Protocol header

Rose will use a 20-byte header for its packets. The headers contain
the following components:

1. *CMD* (8 bits): Contains the command to the fabric or
   interconnected devices, see *Commands* for details.
2. *SRC* (16 bits): Contains the packet source address.
3. *DEST* (16 bits): contains the packet destination address.
4. *ID* (32 bits): contains a packet identifier unique to the source
   in a large time frame.
5. *RESERVED* (64 bits): reserved for future iterations.
6. *CRC* (8 bits): reserved for future iterations incorporating CRC
   checksums.
7. *LEN* (16 bits): length of payload.

## SPI Specifications
We will be using SPI in mode 0, where data is sampled on the falling
edge of the clock pulse and shifted out on the rising edge.
